# class Assets

#### package openfl.utils

Available on all platforms

The Assets class provides a cross-platform interface to access embedded images, fonts, sounds and other resource files.

The contents are populated automatically when an application is compiled using the OpenFL command-line tools, based on the contents of the *.xml project file.

For most platforms, the assets are included in the same directory or package as the application, and the paths are handled automatically. For web content, the assets are preloaded before the start of the rest of the application. You can customize the preloader by extending the `NMEPreloader` class, and specifying a custom preloader using in the project file.

### Static variables

###

`staticcache:IAssetCache`

### Static methods

###

`staticaddEventListener (type:String, listener:Dynamic, useCapture:Bool = false, priority:Int = 0, useWeakReference:Bool = false):Void`

###

`staticdispatchEvent (event:Event):Bool`

###

`staticexists (id:String, ?type:AssetType):Bool`

Returns whether a specific asset exists

Parameters:

`id` | The ID or asset path for the asset
`type` | The asset type to match, or null to match any type

Returns:

Whether the requested asset ID and type exists

###

`staticgetBitmapData (id:String, useCache:Bool = true):BitmapData`

Gets an instance of an embedded bitmap @usage var bitmap = new Bitmap (Assets.getBitmapData ("image.png"));

Parameters:

`id` | The ID or asset path for the bitmap
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)

Returns:

A new BitmapData object

###

`staticgetBytes (id:String):ByteArray`

Gets an instance of an embedded binary asset @usage var bytes = Assets.getBytes ("file.zip");

Parameters:

`id` | The ID or asset path for the asset

Returns:

A new ByteArray object

###

`staticgetFont (id:String, useCache:Bool = true):Font`

Gets an instance of an embedded font @usage var fontName = Assets.getFont ("font.ttf").fontName;

Parameters:

`id` | The ID or asset path for the font
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)

Returns:

A new Font object

###

`staticgetLibrary (name:String):LimeAssetLibrary`

###

`staticgetMovieClip (id:String):MovieClip`

Gets an instance of an included MovieClip @usage var movieClip = Assets.getMovieClip ("library:BouncingBall");

Parameters:

`id` | The ID for the MovieClip

Returns:

A new MovieClip object

###

`staticgetPath (id:String):String`

Gets the file path (if available) for an asset @usage var path = Assets.getPath ("file.txt");

Parameters:

`id` | The ID or asset path for the asset

Returns:

The path to the asset, or null if it does not exist

###

`staticgetSound (id:String, useCache:Bool = true):Sound`

Gets an instance of an embedded sound @usage var sound = Assets.getSound ("sound.wav");

Parameters:

`id` | The ID or asset path for the sound
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)

Returns:

A new Sound object

###

`staticgetText (id:String):String`

Gets an instance of an embedded text asset @usage var text = Assets.getText ("text.txt");

Parameters:

`id` | The ID or asset path for the asset

Returns:

A new String object

###

`statichasEventListener (type:String):Bool`

###

`statichasLibrary (name:String):Bool`

###

`staticisLocal (id:String, ?type:AssetType, useCache:Bool = true):Bool`

Returns whether an asset is "local", and therefore can be loaded synchronously

Parameters:

`id` | The ID or asset path for the asset
`type` | The asset type to match, or null to match any type
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)

Returns:

Whether the asset is local

###

`staticlist (?type:AssetType):Array<String>`

Returns a list of all embedded assets (by type)

Parameters:

`type` | The asset type to match, or null to match any type

Returns:

An array of asset ID values

###

`staticloadBitmapData (id:String, useCache:Bool = true):Future<BitmapData>`

Loads an included bitmap asset asynchronously @usage Assets.loadBitmapData ("image.png").onComplete (handleImage);

Parameters:

`id` | The ID or asset path for the asset
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)
`handler` | (Deprecated) A callback function when the load is completed

Returns:

Returns a Future

###

`staticloadBytes (id:String):Future<ByteArray>`

Loads an included byte asset asynchronously @usage Assets.loadBytes ("file.zip").onComplete (handleBytes);

Parameters:

`id` | The ID or asset path for the asset
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)
`handler` | (Deprecated) A callback function when the load is completed

Returns:

Returns a Future

###

`staticloadFont (id:String, useCache:Bool = true):Future<Font>`

Loads an included font asset asynchronously @usage Assets.loadFont ("font.ttf").onComplete (handleFont);

Parameters:

`id` | The ID or asset path for the asset
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)
`handler` | (Deprecated) A callback function when the load is completed

Returns:

Returns a Future

###

`staticloadLibrary (name:String):Future<LimeAssetLibrary>`

Load an included AssetLibrary

Parameters:

`name` | The name of the AssetLibrary to load
`handler` | (Deprecated) A callback function when the load is completed

Returns:

Returns a Future

###

`staticloadMovieClip (id:String):Future<MovieClip>`

Loads an included MovieClip asset asynchronously @usage Assets.loadMovieClip ("library:BouncingBall").onComplete (handleMovieClip);

Parameters:

`id` | The ID for the asset
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)
`handler` | (Deprecated) A callback function when the load is completed

Returns:

Returns a Future

###

`staticloadMusic (id:String, useCache:Bool = true):Future<Sound>`

Loads an included music asset asynchronously @usage Assets.loadMusic ("music.ogg").onComplete (handleMusic);

Parameters:

`id` | The ID or asset path for the asset
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)
`handler` | (Deprecated) A callback function when the load is completed

Returns:

Returns a Future

###

`staticloadSound (id:String, useCache:Bool = true):Future<Sound>`

Loads an included sound asset asynchronously @usage Assets.loadSound ("sound.wav").onComplete (handleSound);

Parameters:

`id` | The ID or asset path for the asset
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)
`handler` | (Deprecated) A callback function when the load is completed

Returns:

Returns a Future

###

`staticloadText (id:String):Future<String>`

Loads an included text asset asynchronously @usage Assets.loadText ("text.txt").onComplete (handleString);

Parameters:

`id` | The ID or asset path for the asset
`useCache` | (Optional) Whether to allow use of the asset cache (Default: true)
`handler` | (Deprecated) A callback function when the load is completed

Returns:

Returns a Future

###

`staticregisterLibrary (name:String, library:AssetLibrary):Void`

Registers a new AssetLibrary with the Assets class

Parameters:

`name` | The name (prefix) to use for the library
`library` | An AssetLibrary instance to register

###

`staticremoveEventListener (type:String, listener:Dynamic, capture:Bool = false):Void`

###

`staticunloadLibrary (name:String):Void`